//
//  myToken.cpp
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#include "myToken.h"
#include "string.h"
#include "myPanic.h"
#include <stdio.h>
#include "P.h"

void ANTLRToken::init() {
  pText=0;
}

ANTLRToken::ANTLRToken() {
  init();
  setLine(0);
}

ANTLRToken::~ANTLRToken() {
////   dumpNode("Token Destructor");
   delete [] pText;
   pText=0;
}

ANTLRToken::ANTLRToken(ANTLRTokenType tokenTypeNew) {
   init();
   setType(tokenTypeNew);
   setLine(0);
}

ANTLRToken::ANTLRToken(ANTLRTokenType   tokenTypeNew,
               ANTLRChar *  textNew,   
               int      lineNew) {
   init();
   setType(tokenTypeNew);
   setLine(lineNew);
   setText(textNew);
}         

ANTLRToken::ANTLRToken(const ANTLRToken & from) :
    SimpleToken(from) {
   init();
   col=from.col;
   setText(from.pText);
};  

//  create new copy of text - not just another reference to existing text

ANTLRToken & ANTLRToken::operator = (const ANTLRToken & from) {

   this->SimpleToken::operator = (from);

   if (this != &from) {
     col=from.col;
     setText(from.pText);
   };
   return *this;
}      

//  create new copy of text - not just another reference to existing text

void ANTLRToken::setText(const ANTLRChar *s) {

   if (pText != 0) {
      delete [] pText;
      pText=0;
   };
   if (s != 0) {
     pText=new char [strlen(s)+1];
     if (pText == 0) myPanic ("ANTLRToken::setText strdup failed");
     strcpy(pText,s);
   };
}

ANTLRAbstractToken * ANTLRToken::makeToken(ANTLRTokenType   tokenType,
                       ANTLRChar *      text,
                       int          line) {
   return new ANTLRToken(tokenType,text,line);
}

void ANTLRToken::dumpNode(const char * s) {

   char * theText;

   if (s != 0) {printf("%s ",s);};
   if (getType() == Eof) {
     printf("TokenType \"EOF\" Token # %d\n",serial);
   } else {
     if (pText == 0) {
        theText="";
     } else if (strcmp(pText,"\n") == 0) {
    theText="NL";
     } else {
    theText=pText;
     }; 
     printf("TokenType (%s) Text (%s) Token # %d  Line=%d  Col=%d\n",
        P::tokenName(getType()),
        theText,
        serial,     
        getLine(),
        col);
   };
}
