%{
 
/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

/* Demonstrate extremely simple interface between flex and Antlr
   Version 0.1 of 29-May-97
   Caveat Programmer

   Based on flex 2.5.2
*/

#include "flexTokens.h"
%}

%x	LC_COMMENT
%%

"/*"			{yymore();BEGIN(LC_COMMENT);}

<LC_COMMENT>\n		{yytext[--yyleng]=0;return(Comment);}
<LC_COMMENT>.		{yymore();}
<LC_COMMENT>"*/"	{BEGIN(INITIAL);return(Comment);}
<LC_COMMENT><<EOF>>	{return(-Bad_Comment);}

[ \t]*          	/* ignore */
[a-zA-Z]*       	{return (ID);}
[0-9]*          	{return (Num);}
\n              	{return (NL);}

%%

const char * getLexClassName(int startCond) {

  const char *		result;

#define LEXCLASS(name) case name : result=#name; break;

switch (startCond) {

   default:  result=0; break;

//////////////////////////////////////////////////////////////////////////////
//
//  insert the name of your start conditions here using the LEXCLASS macro
//    if you want "const char * getLexClassName(int startCondition)" to work
//
//////////////////////////////////////////////////////////////////////////////

   LEXCLASS(INITIAL)
   LEXCLASS(LC_COMMENT)
};
  return result;
}

//
//  yy_start is declared static by flex
//

int getLexClass() {
   return (YY_START);
}

void setLexClass(int startCond) {
   BEGIN(startCond);
}

//
//  yy_current_buffer declared static by flex
//

void freeFlexBuffer() {
   yy_delete_buffer(yy_current_buffer);
}

//
//  supply default yywrap() - or use %option yywrap
//

extern "C" yywrap() {
   return 1;
}
