//
//  holl.g
//  16-Apr-97
//  demonstrate use of lexclass to accept counted strings
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

<<
#include "DLGLexer.h"
#include "myToken.h"

int main() {

   DLGFileInput     in(stdin);
   DLGLexer     lexer(&in,2000);
   ANTLRTokenBuffer pipe(&lexer,1);
   ANTLRToken       aToken;
   P            parser(&pipe);

   lexer.setToken(&aToken);
   parser.init();
   parser.statement();

   return 0;
}
>>

#lexaction <<static int count;>>

#token HOLLERITH        "[0-9]*"
        <<count=atoi(lextext());
         printf("Count is %d\n",count);
         mode(COUNT);
        >>

#token Eof      "@"
#token ID               "[a-z]*"        <<printf("ID is %s\n",lextext());>>
#token WS               "\ "            <<skip();>>
#token NL               "\n"

#lexclass COUNT
#token  STRING          "~[]"
        <<count--;
          if (count == 0) {
              mode(START);
              printf ("Hollerith string is \"%s\"\n",lextext());
          } else if (ch == '\n') {
              mode(START);
              printf("Hollerith string %s terminated by newline\n",
                lextext());
          } else {
              more();
          };
        >>

class P {

statement      : ( (HOLLERITH STRING | ID )* NL)+ "@";

}
