//
//  predbufex.g
//  29-May-97
//  pccts 1.33MR5
//
//  demonstrates how to perform some change tokenType of tokens in a
//    class derived from ANTLRTokenBuffer when the parser call consume()
//    to get a token
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#header <<>>
<<
#include "myTokenBuffer.h"
#include "DLGLexer.h"
#include "myToken.h"

int main() {

   DLGFileInput     in(stdin);
   DLGLexer     lexer(&in,2000);
   MyTokenBuffer    pipe(&lexer,2);
   ANTLRToken       aToken;
   P            parser(&pipe);

   lexer.setToken(&aToken);
   parser.init();
   parser.statement();

   fclose(stdin);
   fclose(stdout);
   return 0;
}
>>

#token  Eof "@"

#token  X   "x" <<printf("token is x\n");>>
#token  Y   "y" <<printf("token is y\n");>>
#token  A_OR_B  "a | b" <<printf("token is (a|b)\n");>>
#token  A
#token  B

#token  WS    "\ "  <<skip();>>
#token  NL    "\n"  <<skip();>>

class P {
statement
        : ( ax_or_by | bx )* "@" ;
ax_or_by
    : aName X   <<printf("aName x executed\n");>>
        | bName Y   <<printf("bName y executed\n");>>
    ;
bx      : bName X   <<printf("bName x executed\n");>>
    ;
aName   : A ;
bName   : B ;
}
