//
//  varex.g
//
//  29-May-97
//  pccts 1.33MR5
//
//  token with variable length text field allocated from heap
//
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

<<
#include "DLGLexer.h"
#include "myToken.h"
#include "ATokenBuffer.h"
#include "myPanic.h"

int main() {

   DLGFileInput     in(stdin);
   DLGLexer     lexer(&in,2000);

   ANTLRTokenBuffer pipe(&lexer,1);
   ANTLRToken       aToken( (ANTLRTokenType)0 );
   P            parser(&pipe);

   printf("\n");
   printf("Example of handling variable length strings - 7-Nov-95\n");
   printf("A string is terminated by \"$\"\n\n");

   lexer.setToken(&aToken);
   parser.init();
   parser.statement();

   fclose(stdin);
   fclose(stdout);
   return 0;
}
>>

#token  Eof "@"
#token      "$"     <<skip();>>
#token      "$\n"       <<skip();>>
#token  String  "~[\$]+"    // everything to the "$"
                // limited by DLG work area size
class P {

statement : ( s:String <<printf("String:\n%s\n",$s->getText());>> )* "@"
;

}
